/***************************************************************************
 *   Copyright (C) 2010 by santiago González                               *
 *   santigoro@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, see <http://www.gnu.org/licenses/>.  *
 *                                                                         *
 ***************************************************************************/

#ifndef GATE_H
#define GATE_H

#include "logiccomponent.h"

class IoPin;

class Gate : public LogicComponent
{
        Q_OBJECT
    public:
        Gate( QObject* parent, QString type, QString id, int inputs );
        ~Gate();

        QList<ComProperty*> edgeProps();

        virtual void stamp() override;
        virtual void voltChanged() override;
        virtual void runEvent() override{ IoComponent::runOutputs(); }

        bool initState() { return m_initState; }
        void setInitState( bool s) { m_initState = s; }

        virtual void setNumInps( int pins );

    protected:
        virtual bool calcOutput( int inputs );

        bool m_out;
        bool m_initState;

        int m_minInputs;
};

#endif
