/***************************************************************************
 *   Copyright (C) 2020 by santiago González                               *
 *   santigoro@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, see <http://www.gnu.org/licenses/>.  *
 *                                                                         *
 ***************************************************************************/

#ifndef I51USART_H
#define I51USART_H

#include "mcuuart.h"
#include "mcutypes.h"

class McuTimer;

class I51Usart : public McuUsart
{
    public:
        I51Usart( eMcu* mcu, QString name, int number );
        ~I51Usart();

        virtual void configureA( uint8_t newSCON ) override;
        void step();
        uint8_t getBit9();
        void setBit9( uint8_t bit );

    private:
        McuTimer* m_timer1;

        uint8_t m_framesize;
        uint8_t m_counter;

        uint64_t m_div;

        bool m_useTimer;

        regBits_t m_bit9Tx;
        regBits_t m_bit9Rx;
        regBits_t m_SM;
        regBits_t m_REN;
        regBits_t m_SMOD;
};

#endif

